// ***********************************************************************************************************************
// ** File:         eep.h                                                                                               **
// ** Title:        Functions for EEProm                                                                                **
// ** CPU:          ESP-8266                                                                                            **
// ** Created:      15.12.2017                                                                                          **
// ** Revised:      15.12.2017                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include <EEPROM.h>                                                           // 
#include "global.h"                                                           // 
// ***********************************************************************************************************************

// DEFINES **************************************************************************************************************
#define EE_SSID             0                                                 // 
#define EE_WL_PWD           50                                                // 

#define EE_DHCP_SERV        100                                               // 
#define EE_DEV_NAME         101                                               // 
#define EE_IP_ADR           160                                               // EEProm Adresse IP            6 Bytes
#define EE_SUB_ADR          170                                               // EEProm Adresse Subnet Mask   6 Bytes
#define EE_GW_ADR           180                                               // EEProm Adresse Gateway       6 Bytes
#define EE_DNS_ADR          190                                               // EEProm Adresse DNS Server    6 Bytes

#define EE_NTP_ADR          195                                               // 

#define EE_MQTT_SERV        250                                               // 
#define EE_MQTT_BROKER      300                                               // 
#define EE_MQTT_USER        350                                               // 
#define EE_MQTT_PWD         400                                               // 
#define EE_MQTT_TOPIC       450                                               // 

#define EE_EEPROM_OK        505                                               // 
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
extern char             ssid          [50];                                   //
extern char             password      [50];                                   //

extern unsigned char    dhcp_service;                                         //
extern char             dev_name      [50];                                   //
extern IPAddress        ip_adress;                                            //
extern IPAddress        subnet_mask;                                          //
extern IPAddress        dns_server;                                           //
extern IPAddress        gateway;                                              //
extern char             ntp_server    [50];                                   //

extern unsigned char    mqtt_service;                                         //
extern char             mqtt_broker   [50];                                   //
extern char             mqtt_user     [50];                                   //
extern char             mqtt_pass     [50];                                   //
extern char             mqtt_topic    [100];                                  //

extern char             msg           [50];                                   //
// ***********************************************************************************************************************

// FUNCTION **************************************************************************************************************
void      eep_init            ( void );                                       //
void      save_default_config ( void );                                       //
IPAddress eep_read_ip         ( unsigned int eep_address );                   //
void      eep_write_ip        ( IPAddress temp_ip, unsigned int eep_address );//
unsigned int eep_read_string  ( char *buffer_data, unsigned int eep_address );//
void      eep_write_string    ( char *eep_data, unsigned int eep_address );   // 
void      read_eeprom_config  ( void );                                       //
IPAddress http_asc_to_ip      ( String ascip );                               //
// ***********************************************************************************************************************
