// ***********************************************************************************************************************
// ** File:         global.h                                                                                            **
// ** Title:        Some Globals                                                                                        **
// ** CPU:          ESP-8266                                                                                            **
// ** Created:      23.04.2016                                                                                          **
// ** Revised:      23.04.2016                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef GLOBAL_H_                                                           // 
#define GLOBAL_H_                                                           // 
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define TERM_ESC              "\033"
#define TERM_POS(x,y)         "\033["#y";"#x"H"
#define TERM_HOME             "\033[f"
#define TERM_CLEAR            "\033[2J"
#define TERM_CURS_OFF         "\033[?25l"
#define TERM_FONT_BLACK       "\033[30m"
#define TERM_FONT_RED         "\033[31m"
#define TERM_FONT_GREEN       "\033[32m"
#define TERM_FONT_YELLOW      "\033[33m"
#define TERM_FONT_BLUE        "\033[34m"
#define TERM_FONT_MAGENTA     "\033[35m"
#define TERM_FONT_CYAN        "\033[36m"
#define TERM_FONT_WHITE       "\033[37m"

#define TERM_BACK_BLACK       "\033[40m"
#define TERM_BACK_RED         "\033[41m"
#define TERM_BACK_GREEN       "\033[42m"
#define TERM_BACK_YELLOW      "\033[43m"
#define TERM_BACK_BLUE        "\033[44m"
#define TERM_BACK_MAGENTA     "\033[45m"
#define TERM_BACK_CYAN        "\033[46m"
#define TERM_BACK_WHITE       "\033[47m"

#define TERM_FONT_BOLD_ON     "\033[1m"
#define TERM_FONT_BOLD_OFF    "\033[22m"
#define TERM_FONT_LINED_ON    "\033[4m"
#define TERM_FONT_LINED_OFF   "\033[24m"
#define TERM_FONT_BLINK_ON    "\033[5m"
#define TERM_FONT_BLINK_OFF   "\033[25m"
#define TERM_FONT_INVERT_ON   "\033[7m"
#define TERM_FONT_INVERT_OFF  "\033[27m"
#define TERM_FONT_INVISIBLE   "\033[8m"
#define TERM_FONT_VISIBLE     "\033[28m"

// Verdreht Big Endian und Little Endian *********************************************************************************
#define htons( A )            ( ( ( (A) & 0xff00 ) >> 8 ) | ( ( (A) & 0x00ff ) << 8 ) )
#define htonl( A )            ( ( ( (A) & 0xff000000 ) >> 24 ) | ( ( (A) & 0x00ff0000 ) >> 8 ) | \
                              ( ( (A) & 0x0000ff00 ) << 8 ) | ( ( (A) & 0x000000ff ) << 24 ) )
#define ntohs htons
#define ntohl htonl
// ***********************************************************************************************************************

// FUNCTIONS *************************************************************************************************************

// ***********************************************************************************************************************
#endif
