// ***********************************************************************************************************************
// ** File:         mqtt.h                                                                                              **
// ** Title:        Functions for MQTT-Protocol                                                                         **
// ** CPU:          ESP-8266                                                                                            **
// ** Created:      23.12.2017                                                                                          **
// ** Revised:      23.12.2017                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef MQTT_H                                                                //
#define MQTT_H                                                                //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "global.h"                                                           // 
#include "Steckdose.h"                                                        // 
#include <PubSubClient.h>                                                     //
// ***********************************************************************************************************************

// DEFINES **************************************************************************************************************

// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
PubSubClient            client(espClient);                                    //
extern unsigned char    mqtt_service;                                         //
extern char             mqtt_broker   [50];                                   //
extern char             mqtt_user     [50];                                   //
extern char             mqtt_pass     [50];                                   //
extern char             mqtt_topic    [100];                                  //
extern unsigned long    lastReconnectAttempt;                                 // 
// ***********************************************************************************************************************

// FUNCTION **************************************************************************************************************
void      mqtt_connect    ( void );                                           // 
void      mqtt_send_state ( void );                                           // 
void      mqtt_send_date  ( void );                                           // 
void      mqtt_send_switch( void );                                           //
void      callback        ( char* topic, byte* payload, unsigned int length );// 
boolean   reconnect       ( void );                                           // 
// ***********************************************************************************************************************
#endif
